package robots;

public final class StateSetRobotConfiguration<T> {
    private T currentState;
    private Boolean currentCellContents;

    public StateSetRobotConfiguration(T currentState, Boolean currentCellContents) {
        this.currentState = currentState;
        this.currentCellContents = currentCellContents;
    }

    public T getCurrentState() {
        return currentState;
    }

    public Boolean getCurrentCellContents() {
        return currentCellContents;
    }

    @Override
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        return (getClass() == o.getClass() && currentState.equals(((StateSetRobotConfiguration) o).currentState) &&
                currentCellContents.equals(((StateSetRobotConfiguration) o).currentCellContents));
    }

    @Override
    public int hashCode() {
        return currentCellContents.hashCode() + 31 * currentState.hashCode();
    }

}
