package robots;

/**
 * Genericke rozhranie urcene na implementaciu triedami reprezentujucimi programy pre robotov typu StateSetRobot
 * so stavmi typu T.
 */
public interface StateSetRobotProgram<T> {
    /**
     * Metoda, ktora vrati pociatocny stav robota s tymto programom.
     */
    T getInitialState();

    /**
     * Metoda, ktora vezme stav robota a obsah citaneho policka a na zaklade nich vrati instanciu generickej triedy
     * StateSetRobotStep reprezentujucu nasledujuci krok robota s tymto programom.
     *
     * V pripade, ze pre danu dvojicu vstupov nie je definovany ziaden vystup, vrati metoda referenciu null.
     */
    StateSetRobotStep<T> nextStep(T currentState, Boolean currentCellContents);
}
