package robots;

public final class StateSetRobotStep<T> {
    private Move move;
    private T newState;

    public StateSetRobotStep(T newState, Move move) {
        this.newState = newState;
        this.move = move;
    }

    public Move getMove() {
        return move;
    }

    public T getNewState() {
        return newState;
    }

    @Override
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        return (getClass() == o.getClass() && move.equals(((StateSetRobotStep) o).move) &&
                newState.equals(((StateSetRobotStep) o).newState));
    }

    @Override
    public int hashCode() {
        return move.hashCode() + 31 * newState.hashCode();
    }
}
